Viewing Issue Advanced Details
ID Category [?] Severity [?] Reproducibility Date Submitted Last Update
05876 Misc. Critical (emulator) Always Mar 9, 2015, 23:23 Sep 25, 2019, 22:05
Tester Firewave View Status Public Platform MAME (Self-compiled)
Assigned To Kale Resolution Fixed OS
Status [?] Resolved Driver model2.cpp
Version 0.159 Fixed in Version 0.196 Build Debug
Summary 05876: vf2, vf2a, vf2o: AddressSanitizer: heap-buffer-overflow
Description
==12909==ERROR: AddressSanitizer: heap-buffer-overflow on address 0x7feab68f6460 at pc 0x000003ad2f0e bp 0x7feab4768a80 sp 0x7feab4768a78
READ of size 4 at 0x7feab68f6460 thread T5
    #0 0x3ad2f0d in get_texel(unsigned int, unsigned int, int, int, unsigned int*) /home/notroot/trunk/src/mame/video/model2.c:841:2
    #1 0x3ad2f0d in model2_3d_render_2(void*, int, poly_extent const*, void const*, int) /home/notroot/trunk/src/mame/video/model2rd.inc:174
    #2 0x756a9db in poly_item_callback(void*, int) /home/notroot/trunk/src/emu/video/polylgcy.c:1327:5
    #3 0x8b45abe in worker_thread_process(osd_work_queue*, work_thread_info*) /home/notroot/trunk/src/osd/modules/sync/work_osd.c:744:19
    #4 0x8b44e7a in worker_thread_entry(void*) /home/notroot/trunk/src/osd/modules/sync/work_osd.c:668:4
    #5 0x7feadb82c181 in start_thread /build/buildd/eglibc-2.19/nptl/pthread_create.c:312
    #6 0x7fead841c00c in clone /build/buildd/eglibc-2.19/misc/../sysdeps/unix/sysv/linux/x86_64/clone.S:111

0x7feab68f6460 is located 3169 bytes to the right of 2101247-byte region [0x7feab66f4800,0x7feab68f57ff)
allocated by thread T0 here:
    #0 0x114f78b in __interceptor_malloc /home/ben/development/llvm/3.5/final/llvm.src/projects/compiler-rt/lib/asan/asan_malloc_linux.cc:40:3
    #1 0x8b42538 in osd_malloc_array(unsigned long) /home/notroot/trunk/src/osd/modules/lib/osdlib_unix.c:89:9
    #2 0x8419fca in malloc_file_line(unsigned long, char const*, int, bool, bool, bool) /home/notroot/trunk/src/lib/util/corealloc.c:112:25
    #3 0x79811e3 in operator new[](unsigned long, char const*, int) /home/notroot/trunk/src/lib/util/corealloc.h:72:125
    #4 0x79811e3 in dynamic_array<unsigned char>::expand_internal(int) /home/notroot/trunk/src/lib/util/coretmpl.h:115
    #5 0x79811e3 in dynamic_array<unsigned char>::resize(int) /home/notroot/trunk/src/lib/util/coretmpl.h:94
    #6 0x79811e3 in dynamic_array<unsigned char>::resize_and_clear(int, unsigned char) /home/notroot/trunk/src/lib/util/coretmpl.h:99
    #7 0x8089bb7 in memory_block::memory_block(address_space&, unsigned int, unsigned int, void*) /home/notroot/trunk/src/emu/memory.c:3857:4
    #8 0x80650bf in address_space::allocate_memory() /home/notroot/trunk/src/emu/memory.c:2069:25
    #9 0x8061b27 in memory_manager::initialize() /home/notroot/trunk/src/emu/memory.c:1544:3
    #10 0x804c2ec in running_machine::start() /home/notroot/trunk/src/emu/machine.c:256:2
    #11 0x804fb73 in running_machine::run(bool) /home/notroot/trunk/src/emu/machine.c:351:3
    #12 0x8047ee6 in machine_manager::execute() /home/notroot/trunk/src/emu/mame.c:222:11
    #13 0x7e79dbc in cli_frontend::execute(int, char**) /home/notroot/trunk/src/emu/clifront.c:220:15
    #14 0x575d9bb in main /home/notroot/trunk/src/osd/sdl/sdlmain.c:322:9
    #15 0x7fead8342ec4 in __libc_start_main /build/buildd/eglibc-2.19/csu/libc-start.c:287

Thread T5 created by T0 here:
    #0 0x11373bf in pthread_create /home/ben/development/llvm/3.5/final/llvm.src/projects/compiler-rt/lib/asan/asan_interceptors.cc:180:3
    #1 0x8b43141 in osd_thread_create(void* (*)(void*), void*) /home/notroot/trunk/src/osd/modules/sync/sync_tc.c:320:7
    #2 0x8b44b35 in osd_work_queue_alloc(int) /home/notroot/trunk/src/osd/modules/sync/work_osd.c:241:20
    #3 0x756974d in poly_alloc(running_machine&, int, unsigned long, unsigned char) /home/notroot/trunk/src/emu/video/polylgcy.c:339:17
    #4 0x3ac2eb5 in model2_state::video_start_model2() /home/notroot/trunk/src/mame/video/model2.c:2708:11
    #5 0x7f23cf5 in delegate_base<void, _noparam, _noparam, _noparam, _noparam, _noparam, _noparam, _noparam, _noparam, _noparam, _noparam, _noparam, _noparam>::operator()() const /home/notroot/trunk/src/lib/util/delegate.h:649:42
    #6 0x7f23cf5 in driver_device::device_start() /home/notroot/trunk/src/emu/driver.c:229
    #7 0x7e970fc in device_t::start() /home/notroot/trunk/src/emu/device.c:409:2
    #8 0x804f33a in running_machine::start_all_devices() /home/notroot/trunk/src/emu/machine.c:1105:6
    #9 0x804ca64 in running_machine::start() /home/notroot/trunk/src/emu/machine.c:287:2
    #10 0x804fb73 in running_machine::run(bool) /home/notroot/trunk/src/emu/machine.c:351:3
    #11 0x8047ee6 in machine_manager::execute() /home/notroot/trunk/src/emu/mame.c:222:11
    #12 0x7e79dbc in cli_frontend::execute(int, char**) /home/notroot/trunk/src/emu/clifront.c:220:15
    #13 0x575d9bb in main /home/notroot/trunk/src/osd/sdl/sdlmain.c:322:9
    #14 0x7fead8342ec4 in __libc_start_main /build/buildd/eglibc-2.19/csu/libc-start.c:287

SUMMARY: AddressSanitizer: heap-buffer-overflow /home/notroot/trunk/src/mame/video/model2.c:841 get_texel(unsigned int, unsigned int, int, int, unsigned int*)
Shadow bytes around the buggy address:
  0x0ffdd6d16c30: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
  0x0ffdd6d16c40: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
  0x0ffdd6d16c50: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
  0x0ffdd6d16c60: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
  0x0ffdd6d16c70: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
=>0x0ffdd6d16c80: fa fa fa fa fa fa fa fa fa fa fa fa[fa]fa fa fa
  0x0ffdd6d16c90: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
  0x0ffdd6d16ca0: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
  0x0ffdd6d16cb0: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
  0x0ffdd6d16cc0: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
  0x0ffdd6d16cd0: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
Shadow byte legend (one shadow byte represents 8 application bytes):
  Addressable: 00
  Partially addressable: 01 02 03 04 05 06 07
  Heap left redzone: fa
  Heap right redzone: fb
  Freed heap region: fd
  Stack left redzone: f1
  Stack mid redzone: f2
  Stack right redzone: f3
  Stack partial redzone: f4
  Stack after return: f5
  Stack use after scope: f8
  Global redzone: f9
  Global init order: f6
  Poisoned by user: f7
  Container overflow: fc
  ASan internal: fe
Steps To Reproduce
Additional Information
Flags
Regression Version
Affected Sets / Systems vf2, vf2a, vf2o
Attached Files
 
Relationships
There are no relationship linked to this issue.
Notes
2
User avatar
No.11511
B2K24
Moderator
Mar 11, 2015, 18:56
-----------------------------------------------------
Exception at EIP=00000000015ACB85 (get_texel(unsigned int, unsigned int, int, in
t, unsigned int*)+0x006d): ACCESS VIOLATION
While attempting to read memory at 0000000059DAE124
-----------------------------------------------------
RAX=0000000059DAE124 RBX=000000000D220006 RCX=0000000000000000 RDX=000000000020B
124
RSI=0000000000000000 RDI=0000000000000000 RBP=000000005B70FBD0 RSP=000000005B70F
BC0
 R8=00000000000000A4  R9=0000000000000898 R10=0000000000000079 R11=0000000000000
246
R12=0000000000000000 R13=0000000000000000 R14=0000000000000000 R15=0000000000000
000
-----------------------------------------------------
Stack crawl:
  000000005B70FBC0: 00000000015ACB85 (get_texel(unsigned int, unsigned int, int,
 int, unsigned int*)+0x006d)
  000000005B70FCE0: 00000000015ADAB0 (model2_3d_render_6(void*, int, poly_extent
 const*, void const*, int)+0x02cb)
  000000005B70FDC0: 0000000002895FBA (poly_item_callback(void*, int)+0x01a3)
  000000005B70FE30: 0000000003131FCC (worker_thread_process(osd_work_queue*, wor
k_thread_info*)+0x00fb)
  000000005B70FEB0: 0000000003131E06 (worker_thread_entry(void*)+0x00cb)
  000000005B70FEF0: 0000000003132AB1 (worker_thread_entry(void*)+0x0029)
  000000005B70FF20: 000007FEFDE0415F (srand+0x0093)
  000000005B70FF50: 000007FEFDE06EBD (ftime64_s+0x01dd)
  000000005B70FF80: 0000000076A25A4D (BaseThreadInitThunk+0x000d)
  000000005B70FFD0: 0000000076EBBA01 (RtlUserThreadStart+0x0021)
User avatar
No.16958
MetalGod
Senior Tester
Sep 24, 2019, 19:34
Tested in current mame 0.213 after leaving the game running in debug mode for more than 2 hours.
This is no longer happening.
Fixed